%% Computing Polarization Tensor for (1) ellipse and (2) two circular disks

clear all;
close all;
clc;



%% PT for an ellipse
a = 5; b = 3; % parameters of the ellipse
nbPoints = 200; %number of points on the boundary
D = ellipse(a,b,0,0,nbPoints); % Definition of the ellipse


%compute numerical value for PT
lambda = 1;
PT = getPT(D, lambda);
fprintf('The Polarization Tensor for the ellipse is\n')
disp(PT)

%compute theoretical value for PT
k=(2*lambda+1)/(2*lambda-1);
PTtrue = pi*a*b*(k-1)*(a+b)*[1/(a+k*b), 0 ;  0, 1/(a*k+b)];
fprintf('The theoritical PT is\n')
disp(PTtrue)


%% PT for two circular disks

R0 = 1; 
R1 = R0;
R2 = R0;
dist = 0.3;  % two circular unit disks separated by a distance 0.3
   
nbPoints=200;
D1 = ellipse(R0,R0,-dist/2-R0,0,nbPoints);
D2 = ellipse(R0,R0,dist/2+R0,0,nbPoints);

%%% compute numerical value of PT for two disks
lambda = 1;
PT=getPT_2incl(D1,D2,lambda);
fprintf('\n\n The Polarization Tensor for two disks is\n', lambda)
disp(PT)



%%% copmute theoretical value of PT for two disks
alp = sqrt(dist*(R0+dist/4));
s = asinh(alp/R0);
sum11 = 0; sum22=0;
for n=1:1000
    sum11 = sum11 + n*exp(-2*n*s)/(lambda-1/2*exp(-2*n*s));
    sum22 = sum22 + n*exp(-2*n*s)/(lambda+1/2*exp(-2*n*s));
end
PTtrue = 8*pi*alp^2*[sum11,0;0,sum22];

fprintf('The theoretical PT is\n')
disp(PTtrue)







