function Ks = KDstar(D)


M = D.nbPoints;
Ks = zeros(M, M);

for j = 1:M
    xdoty = (D.points(1,j)-D.points(1,:)).*D.normal(1,j)...
        +(D.points(2,j)-D.points(2,:)).*D.normal(2,j);
    
    norm_xy_square = (D.points(1,j)-D.points(1,:)).^2 ...
        +(D.points(2,j)-D.points(2,:)).^2;
    
    
    Ks(j, 1:j-1) = 1/(2*pi)* ...
        xdoty(1:j-1)./norm_xy_square(1:j-1).*D.sigma(1:j-1);
    Ks(j, j+1:M) = 1/(2*pi)* ...
        xdoty(j+1:M)./norm_xy_square(j+1:M).*D.sigma(j+1:M);
    
    
    Ks(j,j) = -1/(4*pi)* ...
        D.avec(:,j)'*D.normal(:,j)/(D.tvec_norm(j)^2)*D.sigma(j);
    

end

end