function M = getPT(D, lambda)


%% Solving integral equation
nbPoints = D.nbPoints;
Ks = KDstar(D);
As = lambda*eye(nbPoints) - Ks;


x1 = D.points(1,:);
x2 = D.points(2,:);

phi1 = As\D.normal(1,:)';
phi2 = As\D.normal(2,:)';

%% Calulate PT
M = zeros(2,2);
M(1,1) = (x1.*phi1')*D.sigma';
M(1,2) = (x2.*phi1')*D.sigma';
M(2,1) = (x1.*phi2')*D.sigma';
M(2,2) = (x2.*phi2')*D.sigma';

